/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.0 Professional
Automatic Program Generator
 Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 14.03.2011
Author  : NeVaDa
Company : 
Comments: 


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>
#include <delay.h>

// Declare your global variables here

unsigned char Mode;

#define Manual 0                            //    
#define Auto 1                              //    
#define Max 2                               //   

#define UP_Button (!PINC.0)        //    
#define DOWN_Button (!PINC.1)  //    
#define MODE_Button (!PINC.2)  //    


void main(void)
{
// Declare your local variables here

enum Direction {UP, DOWN} DIR = UP;         //   

unsigned char Mode_Change_Enabled = 1;    //   

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=0 State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x08;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=P State1=P State0=P 
PORTC=0x07;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x92;
DDRD=0x92;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 125,000 kHz
// Mode: Fast PWM top=0xFF
// OC2 output: Non-Inverted PWM
ASSR=0x00;
TCCR2=0x6C;
TCNT2=0x00;
OCR2=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

while (1)
      {
        delay_ms(50);   //          -     
        //      50mS,         
        if (Mode_Change_Enabled)
        {
            if (MODE_Button)                        //      
            {  
                if ((++Mode) == 3) Mode = 0;   //    
                Mode_Change_Enabled = 0;       //       
            };
        }
        //   ,    
        else if (!MODE_Button) {Mode_Change_Enabled = 1;};
        
        switch (Mode)                                   //   
        {
            case Manual:
            { 
               PORTD.7 = 1; PORTD.1 = 0;        //  
               if (UP_Button)                           //     
                    {   
                        if (++OCR2 == 0) {OCR2 = 255;};
                    };
                if (DOWN_Button)                      //     
                    {
                        if (--OCR2 == 255) {OCR2 = 0;};
                    };
                break;
            }; 
            case Auto:                                    //  
            {  
                PORTD.1 = 1; PORTD.4 = 0;       //   
                if (DIR == UP)                          //  
                {   
                    //    ,  
                    if (++OCR2 == 255) {DIR = DOWN;}
                }
                else   //  
                { 
                    //    ,  
                    if (--OCR2 == 0) {DIR = UP;}                
                }
                break;          
            };
            case Max:    
            {  
                PORTD.4 = 1; PORTD.7 = 0;       //  
                OCR2 = 255;                             //  
            };
        };
      }
}
